%% @file
% fieldscheckeasy.m
%
% @author Loriano Galeotti
%
% @section DISCLAIMER
% This software and documentation (the "Software") were developed at the Food
% and Drug Administration (FDA) by employees of the Federal Government in the
% course of their official duties. Pursuant to Title 17, Section 105 of the
% United States Code, this work is not subject to copyright protection and is
% in the public domain. Permission is hereby granted, free of charge, to any
% person obtaining a copy of the Software, to deal in the Software without
% restriction, including without limitation the rights to use, copy, modify,
% merge, publish, distribute, sublicense, or sell copies of the Software or
% derivatives, and to permit persons to whom the Software is furnished to do
% so. FDA assumes no responsibility whatsoever for use by other parties of
% the Software, its source code, documentation or compiled executables, and
% makes no guarantees, expressed or implied, about its quality, reliability,
%  or any other characteristic. Further, use of this code in no way implies
% endorsement by the FDA or confers any advantage in regulatory decisions.
% Although this software can be redistributed and/or modified freely, we
% ask that any derivative works bear some notice that they are derived from
% it, and any modified versions bear some notice that they have been modified.
%

%%
% @brief populates / checks name-value couples in structs 
% @param in Input struct
% @param varargin [fieldname1, fieldval1,] [fieldname2, fieldval2].. [fieldnameN, fieldvalN]
% @return output struct will be outstruct.fieldname1 = in.fieldname1 (if it was defined) or fieldval1)
function in = fieldscheckeasy(in, varargin)
%populates / checks name-value couples in structs
%
% in Input struct
% varargin [fieldname1, fieldval1,] [fieldname2, fieldval2].. [fieldnameN, fieldvalN]
%
%                                  DISCLAIMER                                  
% This software and documentation (the "Software") were developed at the Food  
% and Drug Administration (FDA) by employees of the Federal Government in the  

% United States Code, this work is not subject to copyright protection and is  
% in the public domain. Permission is hereby granted, free of charge, to any   
% person obtaining a copy of the Software, to deal in the Software without     
% restriction, including without limitation the rights to use, copy, modify,   
% merge, publish, distribute, sublicense, or sell copies of the Software or    
% derivatives, and to permit persons to whom the Software is furnished to do   
% so. FDA assumes no responsibility whatsoever for use by other parties of     
% the Software, its source code, documentation or compiled executables, and    
% makes no guarantees, expressed or implied, about its quality, reliability,   
%  or any other characteristic. Further, use of this code in no way implies    
% endorsement by the FDA or confers any advantage in regulatory decisions.     
% Although this software can be redistributed and/or modified freely, we       
% ask that any derivative works bear some notice that they are derived from    
% it, and any modified versions bear some notice that they have been modified. 
%                                                                              
% Written by: Loriano Galeotti
	ii=1 ; 
	while ii<length(varargin)+1
	    if ~isfield(in, varargin{ii}) || isempty(in.(genvarname(varargin{ii})))
		in.(genvarname(varargin{ii}))= varargin{ii+1}; 
	    end
	    ii = ii +2 ; 
	end
end 
